


<h1><a name="go" id="go">Go</a></h1>
<div class="level1">

<p>

<a href="http://golang.org/" class="urlextern" title="http://golang.org/"  rel="nofollow">Go</a>: <a href="http://en.wikipedia.org/wiki/Go_(programming_language)" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/Go_(programming_language)">Go</a>
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Go" [1-82] -->
<h2><a name="examples" id="examples">Examples</a></h2>
<div class="level2">
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:go&amp;codeblock=0" title="Download Snippet" class="mediafile mf_">makefile</a></dt>
<dd><pre class="code file make">PROG <span class="sy0">=</span> prog_name
&nbsp;
all<span class="sy0">:</span> <span class="sy0">$</span><span class="br0">&#40;</span><span class="re2">PROG</span><span class="br0">&#41;</span>
&nbsp;
<span class="sy0">%:</span> <span class="sy0">%.</span>8
	8l <span class="sy0">-</span>o <span class="re0">$@</span> <span class="re0">$&lt;</span>
&nbsp;
<span class="sy0">%.</span>8<span class="sy0">:</span> <span class="sy0">%.</span>go
	8g <span class="re0">$&lt;</span></pre>
</dd></dl>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:go&amp;codeblock=1" title="Download Snippet" class="mediafile mf_go">hello.go</a></dt>
<dd><pre class="code file c"><span class="coMULTI">/* hello */</span>
&nbsp;
package main <span class="co1">// executável principal sempre deve pertencer a este pacote</span>
&nbsp;
import . <span class="st0">&quot;fmt&quot;</span> <span class="co1">// importa funções de saída formatada (Printf)</span>
&nbsp;
<span class="co1">// função principal (como em C)</span>
func main<span class="br0">&#40;</span><span class="br0">&#41;</span> <span class="br0">&#123;</span>
	<span class="co1">//sem o . no import teríamos que utilizar fmt.Printf</span>
	Printf<span class="br0">&#40;</span><span class="st0">&quot;hello, world<span class="es1">\n</span>&quot;</span><span class="br0">&#41;</span>
<span class="br0">&#125;</span></pre>
</dd></dl>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:go&amp;codeblock=2" title="Download Snippet" class="mediafile mf_go">producer_consumer.go</a></dt>
<dd><pre class="code file c"><span class="coMULTI">/* pc_channel_multi.go */</span>
&nbsp;
package main
&nbsp;
import <span class="br0">&#40;</span>
	. <span class="st0">&quot;fmt&quot;</span>
	<span class="st0">&quot;crypto/rand&quot;</span>
	<span class="st0">&quot;time&quot;</span>
	<span class="st0">&quot;flag&quot;</span>
<span class="br0">&#41;</span>
&nbsp;
func random_between <span class="br0">&#40;</span>begin<span class="sy0">,</span> end int64<span class="br0">&#41;</span> int64 <span class="br0">&#123;</span>
	random_byte <span class="sy0">:=</span> make<span class="br0">&#40;</span><span class="br0">&#91;</span><span class="br0">&#93;</span>byte<span class="sy0">,</span> 1<span class="br0">&#41;</span>
	rand.<span class="me1">Read</span><span class="br0">&#40;</span>random_byte<span class="br0">&#41;</span>
	<span class="kw1">return</span> int64<span class="br0">&#40;</span>random_byte<span class="br0">&#91;</span>0<span class="br0">&#93;</span><span class="br0">&#41;</span> <span class="sy0">%</span> <span class="br0">&#40;</span>end <span class="sy0">-</span> begin <span class="sy0">+</span> 1<span class="br0">&#41;</span> <span class="sy0">+</span> begin
<span class="br0">&#125;</span>
&nbsp;
func random_sleep <span class="br0">&#40;</span><span class="br0">&#41;</span> <span class="br0">&#123;</span>
	time.<span class="me1">Sleep</span><span class="br0">&#40;</span>random_between<span class="br0">&#40;</span>0<span class="sy0">,</span> <span class="sy0">*</span>MAX_SLEEP_TIME<span class="br0">&#41;</span> <span class="sy0">*</span> 10e7<span class="br0">&#41;</span>
<span class="br0">&#125;</span>
&nbsp;
func send <span class="br0">&#40;</span>channel chan <span class="kw4">int</span><span class="sy0">,</span> i <span class="kw4">int</span><span class="br0">&#41;</span> <span class="br0">&#123;</span>
	channel <span class="sy0">&lt;-</span> i
<span class="br0">&#125;</span>
&nbsp;
func recv <span class="br0">&#40;</span>channel chan <span class="kw4">int</span><span class="br0">&#41;</span> <span class="kw4">int</span> <span class="br0">&#123;</span>
	<span class="kw1">return</span> <span class="sy0">&lt;-</span>channel
<span class="br0">&#125;</span>
&nbsp;
func signal <span class="br0">&#40;</span>channel chan <span class="kw4">int</span><span class="br0">&#41;</span> <span class="br0">&#123;</span>
	<span class="kw1">if</span> len<span class="br0">&#40;</span>channel<span class="br0">&#41;</span> <span class="sy0">&lt;</span> cap<span class="br0">&#40;</span>channel<span class="br0">&#41;</span> <span class="sy0">||</span> cap<span class="br0">&#40;</span>channel<span class="br0">&#41;</span> <span class="sy0">==</span> 0 <span class="br0">&#123;</span>
		channel <span class="sy0">&lt;-</span> 0
	<span class="br0">&#125;</span>
<span class="br0">&#125;</span>
&nbsp;
func wait <span class="br0">&#40;</span>channel chan <span class="kw4">int</span><span class="br0">&#41;</span> <span class="br0">&#123;</span>
	<span class="sy0">&lt;-</span>channel
<span class="br0">&#125;</span>
&nbsp;
var <span class="br0">&#40;</span>
	BUFFER_SIZE <span class="sy0">=</span> flag.<span class="me1">Int</span><span class="br0">&#40;</span><span class="st0">&quot;s&quot;</span><span class="sy0">,</span> <span class="nu0">5</span><span class="sy0">,</span> <span class="st0">&quot;BUFFER_SIZE&quot;</span><span class="br0">&#41;</span> <span class="co1">// flag -s</span>
	MAX_SLEEP_TIME <span class="sy0">=</span> flag.<span class="me1">Int64</span><span class="br0">&#40;</span><span class="st0">&quot;t&quot;</span><span class="sy0">,</span> <span class="nu0">5</span><span class="sy0">,</span> <span class="st0">&quot;MAX_SLEEP_TIME&quot;</span><span class="br0">&#41;</span> <span class="co1">// flag -t</span>
	MAX_PRODUCTIONS <span class="sy0">=</span> flag.<span class="me1">Int</span><span class="br0">&#40;</span><span class="st0">&quot;m&quot;</span><span class="sy0">,</span> <span class="nu0">0</span><span class="sy0">,</span> <span class="st0">&quot;MAX_PRODUCTIONS, 0 for infinity&quot;</span><span class="br0">&#41;</span> <span class="co1">// flag -m</span>
	N_PRODUCERS <span class="sy0">=</span> flag.<span class="me1">Int</span><span class="br0">&#40;</span><span class="st0">&quot;p&quot;</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="st0">&quot;N_PRODUCERS&quot;</span><span class="br0">&#41;</span> <span class="co1">// flag -p</span>
	N_CONSUMERS <span class="sy0">=</span> flag.<span class="me1">Int</span><span class="br0">&#40;</span><span class="st0">&quot;c&quot;</span><span class="sy0">,</span> <span class="nu0">3</span><span class="sy0">,</span> <span class="st0">&quot;N_CONSUMERS&quot;</span><span class="br0">&#41;</span> <span class="co1">// flag -c</span>
	pipe <span class="sy0">=</span> make<span class="br0">&#40;</span>chan <span class="kw4">int</span><span class="sy0">,</span> <span class="sy0">*</span>BUFFER_SIZE<span class="br0">&#41;</span>
	quit 	<span class="sy0">=</span> make<span class="br0">&#40;</span>chan <span class="kw4">int</span><span class="br0">&#41;</span>
<span class="br0">&#41;</span>
&nbsp;
func producer <span class="br0">&#40;</span>id <span class="kw4">int</span><span class="br0">&#41;</span> <span class="br0">&#123;</span>
	<span class="kw1">for</span> i <span class="sy0">:=</span> <span class="nu0">0</span><span class="sy0">;</span> i <span class="sy0">&lt;</span> <span class="sy0">*</span>MAX_PRODUCTIONS <span class="sy0">||</span> <span class="sy0">*</span>MAX_PRODUCTIONS <span class="sy0">==</span> <span class="nu0">0</span><span class="sy0">;</span> i<span class="sy0">++</span> <span class="br0">&#123;</span>
		Println<span class="br0">&#40;</span>id<span class="sy0">,</span> <span class="st0">&quot;producing:&quot;</span><span class="sy0">,</span> i <span class="sy0">+</span> id <span class="sy0">*</span> 1e5<span class="br0">&#41;</span>
		send<span class="br0">&#40;</span>pipe<span class="sy0">,</span> i <span class="sy0">+</span> id <span class="sy0">*</span> 1e5<span class="br0">&#41;</span>
		random_sleep<span class="br0">&#40;</span><span class="br0">&#41;</span>
	<span class="br0">&#125;</span>
	signal<span class="br0">&#40;</span>quit<span class="br0">&#41;</span>
<span class="br0">&#125;</span>
&nbsp;
func consumer <span class="br0">&#40;</span>id <span class="kw4">int</span><span class="br0">&#41;</span> <span class="br0">&#123;</span>
	<span class="kw1">for</span> <span class="br0">&#123;</span>
		v <span class="sy0">:=</span> recv<span class="br0">&#40;</span>pipe<span class="br0">&#41;</span>
		<span class="kw1">if</span> closed<span class="br0">&#40;</span>pipe<span class="br0">&#41;</span> <span class="br0">&#123;</span> <span class="co1">// canal fechado?</span>
			<span class="kw2">break</span>
		<span class="br0">&#125;</span>
		Println<span class="br0">&#40;</span><span class="st0">&quot;<span class="es1">\t</span><span class="es1">\t</span><span class="es1">\t</span>&quot;</span><span class="sy0">,</span> id<span class="sy0">,</span> <span class="st0">&quot;consuming:&quot;</span><span class="sy0">,</span> v<span class="br0">&#41;</span>
		random_sleep<span class="br0">&#40;</span><span class="br0">&#41;</span>
	<span class="br0">&#125;</span>
	signal<span class="br0">&#40;</span>quit<span class="br0">&#41;</span>
<span class="br0">&#125;</span>
&nbsp;
func main <span class="br0">&#40;</span><span class="br0">&#41;</span> <span class="br0">&#123;</span>
	flag.<span class="me1">Parse</span><span class="br0">&#40;</span><span class="br0">&#41;</span> <span class="co1">// processa flags</span>
	Println<span class="br0">&#40;</span><span class="st0">&quot;BUFFER_SIZE =&quot;</span><span class="sy0">,</span> <span class="sy0">*</span>BUFFER_SIZE<span class="br0">&#41;</span>
	Println<span class="br0">&#40;</span><span class="st0">&quot;MAX_SLEEP_TIME =&quot;</span><span class="sy0">,</span> <span class="sy0">*</span>MAX_SLEEP_TIME<span class="br0">&#41;</span>
	Println<span class="br0">&#40;</span><span class="st0">&quot;MAX_PRODUCTIONS =&quot;</span><span class="sy0">,</span> <span class="sy0">*</span>MAX_PRODUCTIONS<span class="br0">&#41;</span>
	Println<span class="br0">&#40;</span><span class="st0">&quot;N_PRODUCERS =&quot;</span><span class="sy0">,</span> <span class="sy0">*</span>N_PRODUCERS<span class="br0">&#41;</span>
	Println<span class="br0">&#40;</span><span class="st0">&quot;N_CONSUMERS =&quot;</span><span class="sy0">,</span> <span class="sy0">*</span>N_CONSUMERS<span class="br0">&#41;</span>
	<span class="kw1">for</span> i <span class="sy0">:=</span> <span class="nu0">0</span><span class="sy0">;</span> i <span class="sy0">&lt;</span> <span class="sy0">*</span>N_PRODUCERS<span class="sy0">;</span> i<span class="sy0">++</span> <span class="br0">&#123;</span> <span class="co1">// cria produtores</span>
		go producer<span class="br0">&#40;</span>i <span class="sy0">+</span> 1<span class="br0">&#41;</span>
	<span class="br0">&#125;</span>
	<span class="kw1">for</span> i <span class="sy0">:=</span> <span class="nu0">0</span><span class="sy0">;</span> i <span class="sy0">&lt;</span> <span class="sy0">*</span>N_CONSUMERS<span class="sy0">;</span> i<span class="sy0">++</span> <span class="br0">&#123;</span> <span class="co1">// cria consumidores</span>
		go consumer<span class="br0">&#40;</span>i <span class="sy0">+</span> 1<span class="br0">&#41;</span>
	<span class="br0">&#125;</span>
	<span class="kw1">for</span> i <span class="sy0">:=</span> <span class="nu0">0</span><span class="sy0">;</span> i <span class="sy0">&lt;</span> <span class="sy0">*</span>N_PRODUCERS<span class="sy0">;</span> i<span class="sy0">++</span> <span class="br0">&#123;</span> <span class="co1">// espera o término dos produtores</span>
		wait<span class="br0">&#40;</span>quit<span class="br0">&#41;</span>
	<span class="br0">&#125;</span>
	close<span class="br0">&#40;</span>pipe<span class="br0">&#41;</span>	<span class="co1">// fecha comunicação</span>
	<span class="kw1">for</span> i <span class="sy0">:=</span> <span class="nu0">0</span><span class="sy0">;</span> i <span class="sy0">&lt;</span> <span class="sy0">*</span>N_CONSUMERS<span class="sy0">;</span> i<span class="sy0">++</span> <span class="br0">&#123;</span>	<span class="co1">// espera o término dos consumidores</span>
		wait<span class="br0">&#40;</span>quit<span class="br0">&#41;</span>
	<span class="br0">&#125;</span>
<span class="br0">&#125;</span></pre>
</dd></dl>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Examples" [83-] -->